use std::{path::PathBuf, env};

fn main() {
    println!("cargo:rerun-if-changed=wrapper.hpp");

    let bindings = bindgen::Builder::default()
        .header("wrapper.hpp")
        .allowlist_type(r#"scs_(\w+)"#)
        .allowlist_var(r#"SCS_(\w+)"#)
        .blocklist_item(r#"some_requirement_failed_at_(\d+)"#)
        .blocklist_function(r#"(\w+)_(init|shutdown)(\w*)"#)
        .parse_callbacks(Box::new(bindgen::CargoCallbacks))
        .generate()
        .expect("Unable to generate bindings");

    let out_path = PathBuf::from(env::var("OUT_DIR").unwrap());
    bindings
        .write_to_file(out_path.join("bindings.rs"))
        .expect("Couldn't write bindings!");
}